var ForReading = 1;

function IncludeAnalyzer()
{
	this.m_fso = new ActiveXObject("Scripting.FileSystemObject");
	this.m_includeDirs = new Object;
	this.m_indentLevel = 0;
	this.m_included = new Object;
}

IncludeAnalyzer.prototype.Echo = function(text)
{
	WScript.Echo(text);
}

IncludeAnalyzer.prototype.LocateHeader = function(name)
{
	for (var dir in this.m_includeDirs)
	{
		var path = this.m_includeDirs[dir] + "\\" + name;
		if (this.m_fso.FileExists(path))
		{
			return path;
		}
	}
	return name;
}

IncludeAnalyzer.prototype.ProcessHeader = function(name)
{
	var indent = "";
	for (var i = 0; i < this.m_indentLevel; i++)
	{
		indent += "  ";
	}
	this.Echo(indent + name);
	var path = this.LocateHeader(name);
	if (this.m_fso.FileExists(path) && !this.m_included[path])
	{
		this.m_included[path] = true;
		var header = this.m_fso.OpenTextFile(path, ForReading)
		++this.m_indentLevel;
		this.ProcessFile(header);
		--this.m_indentLevel;
		header.Close();
	}
}

IncludeAnalyzer.prototype.ProcessFile = function(stream)
{
	var include = /^\#include <(.*)>/;
	while (!stream.AtEndOfStream)
	{
		var line = stream.ReadLine();
		var match = include.exec(line);
		if (match)
		{
			this.ProcessHeader(match[1]);
		}
	}
}
